org.keycloak.storage.role

## Interface RoleStorageProviderFactory<T extends RoleStorageProvider>

- All Superinterfaces:
    ComponentFactory<T,RoleStorageProvider>, ConfiguredProvider, ProviderFactory<RoleStorageProvider>

      public interface RoleStorageProviderFactory<T extends RoleStorageProvider>
      extends ComponentFactory<T,RoleStorageProvider>

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default void` | `close()` This is called when the server shuts down.
    `T` | `create(KeycloakSession session, ComponentModel model)` called per Keycloak transaction.
    `default List<ProviderConfigProperty>` | `getCommonProviderConfigProperties()` configuration properties that are common across all RoleStorageProvider implementations
    `default List<ProviderConfigProperty>` | `getConfigProperties()`
    `default String` | `getHelpText()`
    `String` | `getId()` This is the name of the provider.
    `default Map<String,Object>` | `getTypeMetadata()` This is metadata about this component type.
    `default void` | `init(Config.Scope config)` Only called once when the factory is first created.
    `default void` | `onCreate(KeycloakSession session, RealmModel realm, ComponentModel model)` Called when RoleStorageProviderModel is created.
    `default void` | `postInit(KeycloakSessionFactory factory)` Called after all provider factories have been initialized
    `default void` | `validateConfiguration(KeycloakSession session, RealmModel realm, ComponentModel config)` Called before a component is created or updated.

    - ### Methods inherited from interface org.keycloak.component.ComponentFactory

      `create, onUpdate, preRemove`

    - ### Methods inherited from interface org.keycloak.provider.ProviderFactory

      `order`

- - ### Method Detail

    - #### create

          T create(KeycloakSession session,
                   ComponentModel model)

      called per Keycloak transaction.
      Specified by:
        `create` in interface `ComponentFactory<T extends RoleStorageProvider,RoleStorageProvider>`
      Parameters:
        `session` -
        `model` -
      Returns:

    - #### getId

          String getId()

      This is the name of the provider.
      Specified by:
        `getId` in interface `ProviderFactory<RoleStorageProvider>`
      Returns:

    - #### init

          default void init(Config.Scope config)

      Description copied from interface: `ProviderFactory`
      Only called once when the factory is first created. This config is pulled from keycloak_server.json
      Specified by:
        `init` in interface `ProviderFactory<RoleStorageProvider>`

    - #### postInit

          default void postInit(KeycloakSessionFactory factory)

      Description copied from interface: `ProviderFactory`
      Called after all provider factories have been initialized
      Specified by:
        `postInit` in interface `ProviderFactory<RoleStorageProvider>`

    - #### close

          default void close()

      Description copied from interface: `ProviderFactory`
      This is called when the server shuts down.
      Specified by:
        `close` in interface `ProviderFactory<RoleStorageProvider>`

    - #### getHelpText

          default String getHelpText()

      Specified by:
        `getHelpText` in interface `ConfiguredProvider`

    - #### getConfigProperties

          default List<ProviderConfigProperty> getConfigProperties()

      Specified by:
        `getConfigProperties` in interface `ConfiguredProvider`

    - #### validateConfiguration

          default void validateConfiguration(KeycloakSession session,
                                             RealmModel realm,
                                             ComponentModel config)
                                      throws ComponentValidationException

      Description copied from interface: `ComponentFactory`
      Called before a component is created or updated. Allows you to validate the configuration
      Specified by:
        `validateConfiguration` in interface `ComponentFactory<T extends RoleStorageProvider,RoleStorageProvider>`
      Throws:
        `ComponentValidationException`

    - #### onCreate

          default void onCreate(KeycloakSession session,
                                RealmModel realm,
                                ComponentModel model)

      Called when RoleStorageProviderModel is created. This allows you to do initialization of any additional configuration you need to add.
      Specified by:
        `onCreate` in interface `ComponentFactory<T extends RoleStorageProvider,RoleStorageProvider>`
      Parameters:
        `session` -
        `realm` -
        `model` -

    - #### getCommonProviderConfigProperties

          default List<ProviderConfigProperty> getCommonProviderConfigProperties()

      configuration properties that are common across all RoleStorageProvider implementations
      Specified by:
        `getCommonProviderConfigProperties` in interface `ComponentFactory<T extends RoleStorageProvider,RoleStorageProvider>`
      Returns:

    - #### getTypeMetadata

          default Map<String,Object> getTypeMetadata()

      Description copied from interface: `ComponentFactory`
      This is metadata about this component type. Its really configuration information about the component type and not an individual instance
      Specified by:
        `getTypeMetadata` in interface `ComponentFactory<T extends RoleStorageProvider,RoleStorageProvider>`
      Returns:

Copyright © 2021 JBoss by Red Hat. All rights reserved.